#include "mainform.h"

MainForm::MainForm( QWidget * parent, Qt::WindowFlags f)
	: QWidget(parent, f)
{
	QSqlDatabase db = QSqlDatabase::addDatabase("QSQLITE");
	db.setDatabaseName("./db_test.db");
	
	bool ok;
	ok = db.open();
	Q_ASSERT_X(ok, "", db.lastError().text().toAscii());
	
	ok=db.transaction();
	Q_ASSERT_X(ok, "", db.lastError().text().toAscii());
	
	QSqlQuery query;
	QString req;
	
	req=	"CREATE TABLE test_db("
			"id	INTEGER	PRIMARY KEY AUTOINCREMENT NOT NULL, "
			"data	TEXT"
			");";
	ok=query.exec(req);
	Q_ASSERT_X(ok, "", query.lastError().text().toAscii());
	
	req=	"INSERT INTO test_db (data)"
			"VALUES (\"111\")";
	ok=query.exec(req);
	Q_ASSERT_X(ok, "", query.lastError().text().toAscii());
	
	model = new QSqlTableModel(this);
	model->setTable("test_db");
	model->select();
	
	tableView = new QTableView(this);
	tableView->setModel(model);
	
	bAdd = new QPushButton("Add", this);
	bDel = new QPushButton("Del", this);
	
	mainLayout = new QHBoxLayout;
	mainLayout->addWidget(tableView);
	mainLayout->addWidget(bAdd);
	mainLayout->addWidget(bDel);
	
	setLayout(mainLayout);
	
	connect(bAdd, SIGNAL(pressed()), SLOT(Addpressed()));
	connect(bDel, SIGNAL(pressed()), SLOT(Delpressed()));
	connect(model, SIGNAL(beforeInsert(QSqlRecord &)), SLOT(beforeInsertModel(QSqlRecord &)));

}

void MainForm::Addpressed()
{
	
	QModelIndex insertIndex = tableView->currentIndex();
	int row=insertIndex.row();
	qDebug(QString("Row=%1").arg(row).toAscii());
	if (row==-1) row=0;
	model->insertRow(row);
	//model->setData(model->index(row, 0), generateId("test_db"));
	model->setData(model->index(row, 1), "www");
	model->submit();
	insertIndex = model->index(row, 1);
	tableView->setCurrentIndex(insertIndex);
	tableView->edit(insertIndex);	
	
	/*
	QSqlQuery query;
	QString req;
	bool ok;
	
	req=	"INSERT INTO test_db (data)"
		"VALUES (\"www\")";
	//req=req.arg(generateId());
	ok=query.exec(req);
	Q_ASSERT_X(ok, "", query.lastError().text().toAscii());
	*/
}
	
void MainForm::Delpressed()
{
	
	
}

void MainForm::beforeInsertModel(QSqlRecord &record)
{
	record.setValue("id", generateId());
}

int MainForm::generateId()
{
	QSqlQuery query;
	bool ok;
	
	ok=query.exec("SELECT MAX(id) FROM test_db"/*"SELECT last_insert_rowid()"*/);
	Q_ASSERT_X(ok, "", query.lastError().text().toAscii());

	int id;
	if (query.next())
		id = query.value(0).toInt() + 1;
	else
		id=0;
	qDebug(QString("generated_id=%1").arg(id).toAscii());
	return id;
}